/*
 * Copyright (c) 2005 TopCoder, Inc., All Rights Reserved
 */
package com.topcoder.network.synchronization.defaultimpl;

import com.topcoder.network.synchronization.bean.*;
import java.util.*;

/**
 * This class stores the original messages sended by the calling application. It also provides a method to select 
 * a message to pass to the SynchronizationController. The selecting strategy can be specified by MessageSelector,
 * if the selector is not set, FIFO strategy will be used.
 * 
 * @author TCSDESIGNER
 * @version 1.0
 */
public class MessageQueue {
    
    private LinkedList messages = new LinkedList();
    
    private MessageSelector selector = null;
    
    public synchronized int size() {
        return 0;
    }
    
    public synchronized void push(Message message) {
        
    }
    
    public synchronized Message pop() {
        return null;
    }
    
    public synchronized Message pop(String messageId) {
        return null;
    }
    
    public synchronized Message select() {
        if (messages.size() == 0) {
            return null;
        }
        
        if (selector != null) {
            return selector.select();
        }        
        return (Message) messages.getFirst(); 
        
    }
    
    public LinkedList getMessages() {
        return messages;
    }
}
